/*
 * ThornGUI.java
 *
 * Created on May 7, 2004, 9:55 AM
 */

package usgs.thorn;

import java.util.Hashtable;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

/**
 *
 * @author  markstro
 */
public class ThornGUI extends javax.swing.JFrame {
    ThornData data;
    
    /** Creates new form ThornGUI */
    public ThornGUI(ThornData data) {
        this.data = data;
        initComponents();
        setComponetValues();
        
        Hashtable<Integer,JLabel> rainDict = new Hashtable<Integer,JLabel> ();
        rainDict.put(new Integer (0), new JLabel("0.0"));
        rainDict.put(new Integer (10), new JLabel("1.0"));
        rainDict.put(new Integer (20), new JLabel("2.0"));
        rainDict.put(new Integer (30), new JLabel("3.0"));
        rainDict.put(new Integer (40), new JLabel("4.0"));
        rainDict.put(new Integer (50), new JLabel("5.0"));
        rainThresholdSlider.setLabelTable(rainDict);
        
        Hashtable<Integer,JLabel> snowDict = new Hashtable<Integer,JLabel> ();
        snowDict.put(new Integer(-150), new JLabel("-15.0"));
        snowDict.put(new Integer(-120), new JLabel("-12.0"));
        snowDict.put(new Integer(-90), new JLabel("-9.0"));
        snowDict.put(new Integer(-60), new JLabel("-6.0"));
        snowDict.put(new Integer(-30), new JLabel("-3.0"));
        snowDict.put(new Integer(0), new JLabel("0.0"));
        snowThresholdSlider.setLabelTable(snowDict);
    }
    
    public boolean needPlot() {
        return pet_button.isSelected() ||
                aet_button.isSelected() ||
                pot_aet_button.isSelected() ||
                precip_button.isSelected() ||
                precip_pet_button.isSelected() ||
                runoff_button.isSelected() ||
                snow_button.isSelected() ||
                soil_moist_button.isSelected() ||
                surplus_button.isSelected() ||
                direct_ro_button.isSelected() ||
                snow_melt_button.isSelected() ||
                temp_button.isSelected();
    }
    
    public int getNumPlot() {
        int i = 0;
        if (pet_button.isSelected()) i++;
        if (aet_button.isSelected()) i++;
        if (pot_aet_button.isSelected()) i++;
        if (precip_button.isSelected()) i++;
        if (precip_pet_button.isSelected()) i++;
        if (runoff_button.isSelected()) i++;
        if (snow_button.isSelected()) i++;
        if (soil_moist_button.isSelected()) i++;
        if (surplus_button.isSelected()) i++;
        if (temp_button.isSelected()) i++;
        if (direct_ro_button.isSelected()) i++;
        if (snow_melt_button.isSelected()) i++;
        
        return i;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        titlePanel = new javax.swing.JPanel();
        usgs_icon_label = new javax.swing.JLabel();
        title1 = new javax.swing.JLabel();
        mms_icon_label = new javax.swing.JLabel();
        title2 = new javax.swing.JLabel();
        filePanel = new javax.swing.JPanel();
        input_file_button = new javax.swing.JButton();
        paramPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        runoffPanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        runoffValueLabel = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        runoffSlider = new javax.swing.JSlider();
        directrunoffPanel = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        directRunoffValueLabel = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        directRunoffSlider = new javax.swing.JSlider();
        soilMoistPanel = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        soilMoistValueLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        soilMoistSlider = new javax.swing.JSlider();
        latPanel = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        latValueLabel = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        latSlider = new javax.swing.JSlider();
        rainThresholdPanel = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        rainThresholdValueLabel = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        rainThresholdSlider = new javax.swing.JSlider();
        snowThresholdPanel = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        snowThresholdValueLabel = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        snowThresholdSlider = new javax.swing.JSlider();
        meltRatePanel = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        meltRateValueLabel = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        meltRateSlider = new javax.swing.JSlider();
        outputPanel = new javax.swing.JPanel();
        aet_button = new javax.swing.JRadioButton();
        direct_ro_button = new javax.swing.JRadioButton();
        pet_button = new javax.swing.JRadioButton();
        pot_aet_button = new javax.swing.JRadioButton();
        precip_button = new javax.swing.JRadioButton();
        precip_pet_button = new javax.swing.JRadioButton();
        runoff_button = new javax.swing.JRadioButton();
        snow_button = new javax.swing.JRadioButton();
        snow_melt_button = new javax.swing.JRadioButton();
        soil_moist_button = new javax.swing.JRadioButton();
        surplus_button = new javax.swing.JRadioButton();
        temp_button = new javax.swing.JRadioButton();
        runPanel = new javax.swing.JPanel();
        runButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setBackground(new java.awt.Color(204, 204, 255));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        titlePanel.setLayout(new java.awt.GridBagLayout());

        titlePanel.setBackground(new java.awt.Color(0, 51, 153));
        titlePanel.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
        usgs_icon_label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/usgs/thorn/resources/usgs.gif")));
        usgs_icon_label.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        titlePanel.add(usgs_icon_label, gridBagConstraints);

        title1.setFont(new java.awt.Font("Dialog", 1, 24));
        title1.setForeground(new java.awt.Color(255, 255, 255));
        title1.setText("Thornthwaite Monthly");
        title1.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        titlePanel.add(title1, gridBagConstraints);

        mms_icon_label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/usgs/thorn/resources/mms_people.gif")));
        mms_icon_label.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        titlePanel.add(mms_icon_label, gridBagConstraints);

        title2.setFont(new java.awt.Font("Dialog", 1, 24));
        title2.setForeground(new java.awt.Color(255, 255, 255));
        title2.setText("Water Balance");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        titlePanel.add(title2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.ipady = 20;
        getContentPane().add(titlePanel, gridBagConstraints);

        filePanel.setLayout(new java.awt.BorderLayout());

        filePanel.setBackground(new java.awt.Color(204, 204, 255));
        filePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Input File", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 18)));
        input_file_button.setBackground(new java.awt.Color(204, 204, 255));
        input_file_button.setText("<none>");
        input_file_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                inputFileButtonPushed(evt);
            }
        });

        filePanel.add(input_file_button, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(filePanel, gridBagConstraints);

        paramPanel.setLayout(new java.awt.BorderLayout());

        paramPanel.setBackground(new java.awt.Color(204, 204, 255));
        paramPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Input Parameters", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 18)));
        jPanel1.setLayout(new java.awt.GridLayout(4, 2));

        jPanel1.setBackground(new java.awt.Color(204, 204, 255));
        runoffPanel.setLayout(new java.awt.BorderLayout());

        runoffPanel.setBackground(new java.awt.Color(204, 204, 255));
        runoffPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Runoff Factor", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 2, 11)));
        jPanel4.setBackground(new java.awt.Color(204, 204, 255));
        runoffValueLabel.setText("50");
        jPanel4.add(runoffValueLabel);

        jLabel5.setText(" %");
        jPanel4.add(jLabel5);

        runoffPanel.add(jPanel4, java.awt.BorderLayout.NORTH);

        runoffSlider.setBackground(new java.awt.Color(204, 204, 255));
        runoffSlider.setMajorTickSpacing(25);
        runoffSlider.setMinorTickSpacing(10);
        runoffSlider.setPaintLabels(true);
        runoffSlider.setPaintTicks(true);
        runoffSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                runoffSliderChanged(evt);
            }
        });

        runoffPanel.add(runoffSlider, java.awt.BorderLayout.CENTER);

        jPanel1.add(runoffPanel);

        directrunoffPanel.setLayout(new java.awt.BorderLayout());

        directrunoffPanel.setBackground(new java.awt.Color(204, 204, 255));
        directrunoffPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Direct Runoff Factor", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 2, 11)));
        jPanel5.setBackground(new java.awt.Color(204, 204, 255));
        directRunoffValueLabel.setText("5");
        jPanel5.add(directRunoffValueLabel);

        jLabel6.setText(" %");
        jPanel5.add(jLabel6);

        directrunoffPanel.add(jPanel5, java.awt.BorderLayout.NORTH);

        directRunoffSlider.setBackground(new java.awt.Color(204, 204, 255));
        directRunoffSlider.setMajorTickSpacing(25);
        directRunoffSlider.setMinorTickSpacing(10);
        directRunoffSlider.setPaintLabels(true);
        directRunoffSlider.setPaintTicks(true);
        directRunoffSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                directRunoffChanged(evt);
            }
        });

        directrunoffPanel.add(directRunoffSlider, java.awt.BorderLayout.CENTER);

        jPanel1.add(directrunoffPanel);

        soilMoistPanel.setLayout(new java.awt.BorderLayout());

        soilMoistPanel.setBackground(new java.awt.Color(204, 204, 255));
        soilMoistPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Soil-Moisture-Storage Capacity", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 2, 11)));
        jPanel2.setBackground(new java.awt.Color(204, 204, 255));
        soilMoistValueLabel.setText("200");
        jPanel2.add(soilMoistValueLabel);

        jLabel1.setBackground(new java.awt.Color(204, 204, 255));
        jLabel1.setText("Millimeters");
        jPanel2.add(jLabel1);

        soilMoistPanel.add(jPanel2, java.awt.BorderLayout.NORTH);

        soilMoistSlider.setBackground(new java.awt.Color(204, 204, 255));
        soilMoistSlider.setMajorTickSpacing(500);
        soilMoistSlider.setMaximum(1500);
        soilMoistSlider.setMinorTickSpacing(100);
        soilMoistSlider.setPaintLabels(true);
        soilMoistSlider.setPaintTicks(true);
        soilMoistSlider.setValue(200);
        soilMoistSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                soilMoistChanged(evt);
            }
        });

        soilMoistPanel.add(soilMoistSlider, java.awt.BorderLayout.CENTER);

        jPanel1.add(soilMoistPanel);

        latPanel.setLayout(new java.awt.BorderLayout());

        latPanel.setBackground(new java.awt.Color(204, 204, 255));
        latPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Latitude of Location", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 2, 11)));
        jPanel3.setBackground(new java.awt.Color(204, 204, 255));
        latValueLabel.setText("45");
        jPanel3.add(latValueLabel);

        jLabel3.setText("Degrees of Latitude");
        jPanel3.add(jLabel3);

        latPanel.add(jPanel3, java.awt.BorderLayout.NORTH);

        latSlider.setBackground(new java.awt.Color(204, 204, 255));
        latSlider.setMajorTickSpacing(30);
        latSlider.setMaximum(90);
        latSlider.setMinimum(-90);
        latSlider.setMinorTickSpacing(15);
        latSlider.setPaintLabels(true);
        latSlider.setPaintTicks(true);
        latSlider.setValue(45);
        latSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                latChanged(evt);
            }
        });

        latPanel.add(latSlider, java.awt.BorderLayout.CENTER);

        jPanel1.add(latPanel);

        rainThresholdPanel.setLayout(new java.awt.BorderLayout());

        rainThresholdPanel.setBackground(new java.awt.Color(204, 204, 255));
        rainThresholdPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Rain Temperature Threshold", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 2, 11)));
        jPanel6.setBackground(new java.awt.Color(204, 204, 255));
        rainThresholdValueLabel.setText("0.0");
        jPanel6.add(rainThresholdValueLabel);

        jLabel2.setBackground(new java.awt.Color(204, 204, 255));
        jLabel2.setText("Degrees Celsius");
        jPanel6.add(jLabel2);

        rainThresholdPanel.add(jPanel6, java.awt.BorderLayout.NORTH);

        rainThresholdSlider.setBackground(new java.awt.Color(204, 204, 255));
        rainThresholdSlider.setMajorTickSpacing(10);
        rainThresholdSlider.setMaximum(50);
        rainThresholdSlider.setMinorTickSpacing(5);
        rainThresholdSlider.setPaintLabels(true);
        rainThresholdSlider.setPaintTicks(true);
        rainThresholdSlider.setValue(0);
        rainThresholdSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                rainThresholdChanged(evt);
            }
        });

        rainThresholdPanel.add(rainThresholdSlider, java.awt.BorderLayout.CENTER);

        jPanel1.add(rainThresholdPanel);

        snowThresholdPanel.setLayout(new java.awt.BorderLayout());

        snowThresholdPanel.setBackground(new java.awt.Color(204, 204, 255));
        snowThresholdPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Snow Temperature Threshold", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 2, 11)));
        jPanel7.setBackground(new java.awt.Color(204, 204, 255));
        snowThresholdValueLabel.setText("0.0");
        jPanel7.add(snowThresholdValueLabel);

        jLabel4.setBackground(new java.awt.Color(204, 204, 255));
        jLabel4.setText("Degrees Celsius");
        jPanel7.add(jLabel4);

        snowThresholdPanel.add(jPanel7, java.awt.BorderLayout.NORTH);

        snowThresholdSlider.setBackground(new java.awt.Color(204, 204, 255));
        snowThresholdSlider.setMajorTickSpacing(30);
        snowThresholdSlider.setMaximum(0);
        snowThresholdSlider.setMinimum(-150);
        snowThresholdSlider.setMinorTickSpacing(10);
        snowThresholdSlider.setPaintLabels(true);
        snowThresholdSlider.setPaintTicks(true);
        snowThresholdSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                snowThresholdChnaged(evt);
            }
        });

        snowThresholdPanel.add(snowThresholdSlider, java.awt.BorderLayout.CENTER);

        jPanel1.add(snowThresholdPanel);

        meltRatePanel.setLayout(new java.awt.BorderLayout());

        meltRatePanel.setBackground(new java.awt.Color(204, 204, 255));
        meltRatePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Maximum Melt Rate", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 2, 11)));
        jPanel8.setBackground(new java.awt.Color(204, 204, 255));
        meltRateValueLabel.setText("50");
        jPanel8.add(meltRateValueLabel);

        jLabel7.setBackground(new java.awt.Color(204, 204, 255));
        jLabel7.setText("%");
        jPanel8.add(jLabel7);

        meltRatePanel.add(jPanel8, java.awt.BorderLayout.NORTH);

        meltRateSlider.setBackground(new java.awt.Color(204, 204, 255));
        meltRateSlider.setMajorTickSpacing(25);
        meltRateSlider.setMinorTickSpacing(10);
        meltRateSlider.setPaintLabels(true);
        meltRateSlider.setPaintTicks(true);
        meltRateSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                meltRateChanged(evt);
            }
        });

        meltRatePanel.add(meltRateSlider, java.awt.BorderLayout.CENTER);

        jPanel1.add(meltRatePanel);

        paramPanel.add(jPanel1, java.awt.BorderLayout.NORTH);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(paramPanel, gridBagConstraints);

        outputPanel.setLayout(new java.awt.GridLayout(4, 3));

        outputPanel.setBackground(new java.awt.Color(204, 204, 255));
        outputPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), " Output Plots", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 18)));
        aet_button.setBackground(new java.awt.Color(204, 204, 255));
        aet_button.setFont(new java.awt.Font("Dialog", 2, 11));
        aet_button.setText("Actual ET");
        aet_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aet_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(aet_button);

        direct_ro_button.setBackground(new java.awt.Color(204, 204, 255));
        direct_ro_button.setFont(new java.awt.Font("Dialog", 2, 11));
        direct_ro_button.setText("Direct Runoff");
        direct_ro_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                direct_ro_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(direct_ro_button);

        pet_button.setBackground(new java.awt.Color(204, 204, 255));
        pet_button.setFont(new java.awt.Font("Dialog", 2, 11));
        pet_button.setText("Potential ET");
        pet_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pet_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(pet_button);

        pot_aet_button.setBackground(new java.awt.Color(204, 204, 255));
        pot_aet_button.setFont(new java.awt.Font("Dialog", 2, 11));
        pot_aet_button.setText("Potential ET - Actual ET");
        pot_aet_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pot_aet_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(pot_aet_button);

        precip_button.setBackground(new java.awt.Color(204, 204, 255));
        precip_button.setFont(new java.awt.Font("Dialog", 2, 11));
        precip_button.setText("Precipitation");
        precip_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                precip_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(precip_button);

        precip_pet_button.setBackground(new java.awt.Color(204, 204, 255));
        precip_pet_button.setFont(new java.awt.Font("Dialog", 2, 11));
        precip_pet_button.setText("Precip - Pot ET");
        precip_pet_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                precip_pet_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(precip_pet_button);

        runoff_button.setBackground(new java.awt.Color(204, 204, 255));
        runoff_button.setFont(new java.awt.Font("Dialog", 2, 11));
        runoff_button.setText("Runoff");
        runoff_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runoff_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(runoff_button);

        snow_button.setBackground(new java.awt.Color(204, 204, 255));
        snow_button.setFont(new java.awt.Font("Dialog", 2, 11));
        snow_button.setText("Snow Storage");
        snow_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                snow_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(snow_button);

        snow_melt_button.setBackground(new java.awt.Color(204, 204, 255));
        snow_melt_button.setFont(new java.awt.Font("Dialog", 2, 11));
        snow_melt_button.setText("Snow Melt");
        snow_melt_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                snow_melt_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(snow_melt_button);

        soil_moist_button.setBackground(new java.awt.Color(204, 204, 255));
        soil_moist_button.setFont(new java.awt.Font("Dialog", 2, 11));
        soil_moist_button.setText("Soil Moisture Storage");
        soil_moist_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                soil_moist_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(soil_moist_button);

        surplus_button.setBackground(new java.awt.Color(204, 204, 255));
        surplus_button.setFont(new java.awt.Font("Dialog", 2, 11));
        surplus_button.setText("Surplus");
        surplus_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                surplus_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(surplus_button);

        temp_button.setBackground(new java.awt.Color(204, 204, 255));
        temp_button.setFont(new java.awt.Font("Dialog", 2, 11));
        temp_button.setText("Temperature");
        temp_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                temp_buttonActionPerformed(evt);
            }
        });

        outputPanel.add(temp_button);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(outputPanel, gridBagConstraints);

        runPanel.setBackground(new java.awt.Color(204, 204, 255));
        runPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Run", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 18)));
        runButton.setBackground(new java.awt.Color(204, 204, 255));
        runButton.setText("Run Thornthwaite Model");
        runButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runButtonPushed(evt);
            }
        });

        runPanel.add(runButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(runPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void direct_ro_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_direct_ro_buttonActionPerformed
        data.setVariablePlotted("rodirect", direct_ro_button.isSelected());
    }//GEN-LAST:event_direct_ro_buttonActionPerformed
    
    private void snow_melt_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_snow_melt_buttonActionPerformed
        data.setVariablePlotted("snowMelt", snow_melt_button.isSelected());
    }//GEN-LAST:event_snow_melt_buttonActionPerformed

    private void meltRateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_meltRateChanged
        meltRateValueLabel.setText("" + meltRateSlider.getValue());
    }//GEN-LAST:event_meltRateChanged

    private void snowThresholdChnaged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_snowThresholdChnaged
        snowThresholdValueLabel.setText("" + snowThresholdSlider.getValue() / 10.0);
    }//GEN-LAST:event_snowThresholdChnaged

    private void rainThresholdChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_rainThresholdChanged
        rainThresholdValueLabel.setText("" + rainThresholdSlider.getValue() / 10.0);
    }//GEN-LAST:event_rainThresholdChanged

    private void directRunoffChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_directRunoffChanged
        directRunoffValueLabel.setText("" + directRunoffSlider.getValue());
    }//GEN-LAST:event_directRunoffChanged

    private void temp_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_temp_buttonActionPerformed
        data.setVariablePlotted("temp", temp_button.isSelected());
    }//GEN-LAST:event_temp_buttonActionPerformed

    private void runoff_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runoff_buttonActionPerformed
        data.setVariablePlotted("runoff", runoff_button.isSelected());
    }//GEN-LAST:event_runoff_buttonActionPerformed

    private void surplus_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_surplus_buttonActionPerformed
        data.setVariablePlotted("surplus", surplus_button.isSelected());
    }//GEN-LAST:event_surplus_buttonActionPerformed

    private void snow_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_snow_buttonActionPerformed
        data.setVariablePlotted("snow", snow_button.isSelected());
    }//GEN-LAST:event_snow_buttonActionPerformed

    private void pot_aet_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pot_aet_buttonActionPerformed
        data.setVariablePlotted("petAet", pot_aet_button.isSelected());
    }//GEN-LAST:event_pot_aet_buttonActionPerformed

    private void aet_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aet_buttonActionPerformed
        data.setVariablePlotted("aet", aet_button.isSelected());
    }//GEN-LAST:event_aet_buttonActionPerformed

    private void soil_moist_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_soil_moist_buttonActionPerformed
        data.setVariablePlotted("soilMoist", soil_moist_button.isSelected());
    }//GEN-LAST:event_soil_moist_buttonActionPerformed

    private void precip_pet_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_precip_pet_buttonActionPerformed
        data.setVariablePlotted("precipPet", precip_pet_button.isSelected());
    }//GEN-LAST:event_precip_pet_buttonActionPerformed

    private void precip_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_precip_buttonActionPerformed
        data.setVariablePlotted("precip", precip_button.isSelected());
    }//GEN-LAST:event_precip_buttonActionPerformed

    private void pet_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pet_buttonActionPerformed
        data.setVariablePlotted("pet", pet_button.isSelected());
    }//GEN-LAST:event_pet_buttonActionPerformed
    
    private void latChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_latChanged
        latValueLabel.setText("" + latSlider.getValue());
    }//GEN-LAST:event_latChanged
    
    private void soilMoistChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_soilMoistChanged
        soilMoistValueLabel.setText("" + soilMoistSlider.getValue());
    }//GEN-LAST:event_soilMoistChanged
    
    private void runoffSliderChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_runoffSliderChanged
        runoffValueLabel.setText("" + runoffSlider.getValue());
    }//GEN-LAST:event_runoffSliderChanged
        
    private void inputFileButtonPushed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_inputFileButtonPushed
        JFileChooser fc = new JFileChooser(data.getInputFile());
        int ret = fc.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            data.setInputFile(fc.getSelectedFile());
            data.readInput();
            input_file_button.setText(data.getInputFile().getAbsolutePath());
        }
    }//GEN-LAST:event_inputFileButtonPushed
    
    private void runButtonPushed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runButtonPushed
        getComponetValues();
        
        if (data.getNumTimeSteps() == -1) {
            if (data.getInputFile() == null) {
                JOptionPane.showMessageDialog(this, "Set your input data file!", "Thornthwaite IO Error", JOptionPane.ERROR_MESSAGE);
                return;
            } else {
                JOptionPane.showMessageDialog(this,
                        "Problem with data: \n" + data.getInputFile(),
                        "Thornthwaite IO Error",
                        JOptionPane.ERROR_MESSAGE);
                return;
            }
        }
        
        Thornthwaite t = new Thornthwaite(data);
        
        new ThornReport(this, data);
        
        if (needPlot()) {
            ThornPlotter plot = new ThornPlotter(this, data);
            plot.setSize(700,500);
            plot.setVisible(true);
        }
        
    }//GEN-LAST:event_runButtonPushed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /** Set the GUI components according to the GUI data model */
    private void setComponetValues() {
        soilMoistSlider.setValue((int)(data.getParameterValue("soilMoistureStorage")));
        latSlider.setValue((int)(data.getParameterValue("latitude")));
        runoffSlider.setValue((int)(data.getParameterValue("runoffFactor")));
        directRunoffSlider.setValue((int)(data.getParameterValue("directRunoffFactor")));
        rainThresholdSlider.setValue((int)(data.getParameterValue("rainTempThreshold") * 10.0));
        snowThresholdSlider.setValue((int)(data.getParameterValue("snowTempThreshold") * 10.0));
        meltRateSlider.setValue((int)(data.getParameterValue("maxMeltRate")));
    }
    
    /** Set the GUI data model according to the GUI components */
    private void getComponetValues() {
        data.setParameterValue("soilMoistureStorage", (double)(soilMoistSlider.getValue()));
        data.setParameterValue("latitude", (double)(latSlider.getValue()));
        data.setParameterValue("runoffFactor", (double)(runoffSlider.getValue()));
        data.setParameterValue("directRunoffFactor", (double)(directRunoffSlider.getValue()));
        data.setParameterValue("rainTempThreshold", (double)(rainThresholdSlider.getValue()) / 10.0);
        data.setParameterValue("snowTempThreshold", (double)(snowThresholdSlider.getValue()) / 10.0);
        data.setParameterValue("maxMeltRate", (double)(meltRateSlider.getValue()));
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton aet_button;
    private javax.swing.JSlider directRunoffSlider;
    private javax.swing.JLabel directRunoffValueLabel;
    private javax.swing.JRadioButton direct_ro_button;
    private javax.swing.JPanel directrunoffPanel;
    private javax.swing.JPanel filePanel;
    private javax.swing.JButton input_file_button;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel latPanel;
    private javax.swing.JSlider latSlider;
    private javax.swing.JLabel latValueLabel;
    private javax.swing.JPanel meltRatePanel;
    private javax.swing.JSlider meltRateSlider;
    private javax.swing.JLabel meltRateValueLabel;
    private javax.swing.JLabel mms_icon_label;
    private javax.swing.JPanel outputPanel;
    private javax.swing.JPanel paramPanel;
    private javax.swing.JRadioButton pet_button;
    private javax.swing.JRadioButton pot_aet_button;
    private javax.swing.JRadioButton precip_button;
    private javax.swing.JRadioButton precip_pet_button;
    private javax.swing.JPanel rainThresholdPanel;
    private javax.swing.JSlider rainThresholdSlider;
    private javax.swing.JLabel rainThresholdValueLabel;
    private javax.swing.JButton runButton;
    private javax.swing.JPanel runPanel;
    private javax.swing.JPanel runoffPanel;
    private javax.swing.JSlider runoffSlider;
    private javax.swing.JLabel runoffValueLabel;
    private javax.swing.JRadioButton runoff_button;
    private javax.swing.JPanel snowThresholdPanel;
    private javax.swing.JSlider snowThresholdSlider;
    private javax.swing.JLabel snowThresholdValueLabel;
    private javax.swing.JRadioButton snow_button;
    private javax.swing.JRadioButton snow_melt_button;
    private javax.swing.JPanel soilMoistPanel;
    private javax.swing.JSlider soilMoistSlider;
    private javax.swing.JLabel soilMoistValueLabel;
    private javax.swing.JRadioButton soil_moist_button;
    private javax.swing.JRadioButton surplus_button;
    private javax.swing.JRadioButton temp_button;
    private javax.swing.JLabel title1;
    private javax.swing.JLabel title2;
    private javax.swing.JPanel titlePanel;
    private javax.swing.JLabel usgs_icon_label;
    // End of variables declaration//GEN-END:variables
    
}
